#include <stdio.h>
#ifndef __LCC__
#include "pico/stdlib.h"
#endif

#include "EA_TFT.h"

//-------------------------------------------------------------------------------------------------

#define TFT009   1
#define TFT015   2
#define TFT020   3
#define TFT028   4
#define TFT035   5
#define TFT024   6

#include "bmp\DisplayVisions_140x60.h"

#ifdef TFT009
#include "bmp\Flower_09.h"
#include "bmp\Papagei_09.h"
#endif

#ifdef TFT015
#include "bmp\Flower_15.h"
#include "bmp\Biene_15.h"
#endif

#ifdef TFT020
#include "bmp\Flower_20.h"
#include "bmp\Frosch_20.h"
#endif

#ifdef TFT024
#include "bmp\Flower_24.h"
#include "bmp\Bunny_24.h"
#endif

#ifdef TFT028
#include "bmp\Flower_28.h"
#include "bmp\Chamaeleon_28.h"
#endif

#ifdef TFT035
#include "bmp\Flower_35.h"
#include "bmp\Eule_35.h"
#endif

//-------------------------------------------------------------------------------------------------

void Screen(int nr)
{
  uint16_t x,y,s, background, Portrait = (gTFTAngle==0 || gTFTAngle==180);

  if(nr == 255)
   { TFTclear(BLACK); 
     setTFTcolor(YELLOW, BLUE);
     setTFTfont(FONT_8X16, 1,1);
     TFTtext(0,0, "clear");
     TFTtext(gTFTwidth-32,0, "demo");
   }
  else
   { switch(gTFTmodul)
      {
#ifdef TFT009
     case EA_TFT009: switch(nr)
                      { case 1:  background = RGB565(155,0,150);
                                 TFTfill(WHITE, 0,0, gTFTwidth-1, 19);
                                 TFTfill(background, 0,20, gTFTwidth-1, gTFTheight-1);
                                 setTFTcolor(BLACK, WHITE);
                                 if(Portrait)
                                  { setTFTfont(FONT_7X12, 1,1);
                                    TFTtext(2,4, "TFT009-81AI");
                                    setTFTcolor(WHITE, background);
                                    setTFTfont(FONT_6X8, 1,1);
                                    x = 1;  y = 30;  s = 15;
                                             TFTtext(x,y, "- 0.96\" TFT");
                                    y += s;  TFTtext(x,y, "- 3.3V supply");
                                    y += s;  TFTtext(x,y, "- 160x80 dots");
                                    y += s;  TFTtext(x,y, "- wide angle");
                                    y += s;  TFTtext(x,y, "- -20\xF8..+70\xF8");
                                    y += s;  TFTtext(x,y, "- 3/4-wireSPI");
                                    y += s;  TFTtext(x,y, "- ST7735S");
                                    y += s;  TFTtext(x,y, "- PCAP (opt.)");
                                  }
                                 else
                                  { setTFTfont(FONT_8X16, 1,1);
                                    TFTtext(36,2, "TFT009-81AI");
                                    setTFTcolor(WHITE, background);
                                    setTFTfont(FONT_7X12, 1,1);
                                    x = 5;  y = 24;  s = 14;
                                             TFTtext(x,y, "- 0.96\" low-power TFT");
                                    y += s;  TFTtext(x,y, "- 3.3 V single supply");
                                    y += s;  TFTtext(x,y, "- 160x80 dots");
                                    y += s;  TFTtext(x,y, "- wide viewing angle");
                                  }
                              break;

                        case 2:  if(Portrait)
                                    TFTbitmap(0,0, Flower_09, 15,0);
                                 else
                                    TFTbitmap(0,0, Flower_09, 0,68);
                              break;

                        case 3:  if(Portrait)
                                    TFTbitmap(0,0, Papagei_09, 8,0);
                                 else
                                    TFTbitmap(0,0, Papagei_09, 0,2);
                              break;
                       }
                   break;
#endif

#ifdef TFT015
     case EA_TFT015: switch(nr)
                      { case 1:  background = RGB565(190,0,100);
                                 TFTbitmap(0,0, DisplayVisions_140x60, 0,0);
                                 TFTfill(WHITE, 140,0, gTFTwidth-1, 59);
                                 setTFTcolor(BLACK, WHITE);
                                 setTFTfont(FONT_8X16, 1,2);
                                 TFTtext(143,14, "TFT015-22AI");
                                 TFTfill(background, 0,60, gTFTwidth-1, gTFTheight-1);
                                 setTFTcolor(WHITE, background);
                                 setTFTfont(FONT_8X16, 1,1);
                                 x = 25;  y = 66;  s = 19;
                                          TFTtext(x,y, "- 1.5\" IPS TFT-Display");
                                 y += s;  TFTtext(x,y, "- 240x240 dots");
                                 y += s;  TFTtext(x,y, "- 3.3 V single supply");
                                 y += s;  TFTtext(x,y, "- -20\xF8..+70\xF8 (TOP.)");
                                 y += s;  TFTtext(x,y, "- controller ST7789V");
                                 y += s;  TFTtext(x,y, "- wide viewing angle");
                                 y += s;  TFTtext(x,y, "- 18-Bit RGB interface");
                                 y += s;  TFTtext(x,y, "- or 8/16-Bit parallel");
                                 y += s;  TFTtext(x,y, "- or serial SPI");
                              break;

                        case 2:  TFTbitmap(0,0, Flower_15, 0,0);
                              break;

                        case 3:  TFTbitmap(0,0, Biene_15, 0,0);
                              break;
                       }
                   break;
#endif

#ifdef TFT020
     case EA_TFT020: switch(nr)
                      { case 1:  background = RGB565(0,100,190);
                                 TFTbitmap(0,0, DisplayVisions_140x60, 0,0);
                                 TFTfill(WHITE, 140,0, gTFTwidth-1, 59);
                                 setTFTcolor(BLACK, WHITE);
                                 x = (Portrait) ? 1 : 2;
                                 setTFTfont(FONT_8X16, x,2);
                                 TFTtext(143,14, "TFT020-23AI");
                                 TFTfill(background, 0,60, gTFTwidth-1, gTFTheight-1);
                                 setTFTcolor(WHITE, background);
                                 setTFTfont(FONT_8X16, 1,1);
                                 if(Portrait)
                                  {  x = 25;  y = 80;  s = 24; }
                                 else
                                  {  x = 60;  y = 66;  s = 19; }
                                          TFTtext(x,y, "- 2.0\" IPS TFT-Display");
                                 y += s;  TFTtext(x,y, "- 240x320 dots");
                                 y += s;  TFTtext(x,y, "- 3.3 V single supply");
                                 y += s;  TFTtext(x,y, "- -20\xF8..+70\xF8 (TOP.)");
                                 y += s;  TFTtext(x,y, "- controller ST7789V");
                                 y += s;  TFTtext(x,y, "- wide viewing angle");
                                 y += s;  TFTtext(x,y, "- 18-Bit RGB interface");
                                 y += s;  TFTtext(x,y, "- or 8/16-Bit parallel");
                                 y += s;  TFTtext(x,y, "- or serial SPI");
                              break;

                        case 2:  if(Portrait)
                                    TFTbitmap(0,0, Flower_20, 64,0);
                                 else
                                    TFTbitmap(0,0, Flower_20, 0,45);
                              break;

                        case 3:  if(Portrait)
                                    TFTbitmap(0,0, Frosch_20, 8,0);
                                 else
                                    TFTbitmap(0,0, Frosch_20, 0,24);
                              break;
                       }
                   break;
#endif

#ifdef TFT024
     case EA_TFT024: switch(nr)
                      { case 1:  background = RGB565(190,190,190);
                                 TFTfill(background, 0,0, gTFTwidth-1, 62);
                                 TFTbitmap(0,0, DisplayVisions_140x60, 0,0);
                                 setTFTcolor(BLACK, background);
                                 x = (Portrait) ? 1 : 2;
                                 setTFTfont(FONT_8X16, x,2);
                                 TFTtext(143,14, "TFT024-23AT");
                                 TFTfill(WHITE, 0,63, gTFTwidth-1, gTFTheight-1);
                                 setTFTcolor(BLACK, WHITE);
                                 setTFTfont(FONT_8X16, 1,1);
                                 if(Portrait)
                                  {  x = 25;  y = 80;  s = 24; }
                                 else
                                  {  x = 60;  y = 68;  s = 19; }
                                          TFTtext(x,y, "- 2.4\" transflective TFT");
                                 y += s;  TFTtext(x,y, "- sunlight readable");
                                 y += s;  TFTtext(x,y, "- 240x320 dots");
                                 y += s;  TFTtext(x,y, "- 3.3 V single supply");
                                 y += s;  TFTtext(x,y, "- -20\xF8..+70\xF8 (TOP.)");
                                 y += s;  TFTtext(x,y, "- controller ST7789V");
                                 y += s;  TFTtext(x,y, "- 18-Bit RGB interface");
                                 y += s;  TFTtext(x,y, "- or 8/16-Bit parallel");
                                 y += s;  TFTtext(x,y, "- or serial SPI");
                              break;

                        case 2:  if(Portrait)
                                    TFTbitmap(0,0, Flower_24, 40,0);
                                 else
                                    TFTbitmap(0,0, Flower_24, 0,53);
                              break;

                        case 3:  if(Portrait)
                                    TFTbitmap(0,0, Bunny_24, 80,0);
                                 else
                                    TFTbitmap(0,0, Bunny_24, 0,80);
                              break;
                     }
                   break;
#endif

#ifdef TFT028
     case EA_TFT028: switch(nr)
                      { case 1:  background = RGB565(77,190,0);
                                 TFTbitmap(0,0, DisplayVisions_140x60, 0,0);
                                 TFTfill(WHITE, 140,0, gTFTwidth-1, 59);
                                 setTFTcolor(BLACK, WHITE);
                                 x = (Portrait) ? 1 : 2;
                                 setTFTfont(FONT_8X16, x,2);
                                 TFTtext(143,14, "TFT028-23AI");
                                 TFTfill(background, 0,60, gTFTwidth-1, gTFTheight-1);
                                 setTFTcolor(WHITE, background);
                                 setTFTfont(FONT_8X16, 1,1);
                                 if(Portrait)
                                  {  x = 25;  y = 80;  s = 24; }
                                 else
                                  {  x = 60;  y = 66;  s = 19; }
                                          TFTtext(x,y, "- 2.8\" IPS TFT-Display");
                                 y += s;  TFTtext(x,y, "- 240x320 dots");
                                 y += s;  TFTtext(x,y, "- 3.3 V single supply");
                                 y += s;  TFTtext(x,y, "- -20\xF8..+70\xF8 (TOP.)");
                                 y += s;  TFTtext(x,y, "- controller ST7789V");
                                 y += s;  TFTtext(x,y, "- wide viewing angle");
                                 y += s;  TFTtext(x,y, "- 18-Bit RGB interface");
                                 y += s;  TFTtext(x,y, "- or 8/16-Bit parallel");
                                 y += s;  TFTtext(x,y, "- or serial SPI");
                              break;

                        case 2:  if(Portrait)
                                    TFTbitmap(0,0, Flower_28, 70,0);
                                 else
                                    TFTbitmap(0,0, Flower_28, 0,66);
                              break;

                        case 3:  if(Portrait)
                                    TFTbitmap(0,0, Chamaeleon_28, 45,0);
                                 else
                                    TFTbitmap(0,0, Chamaeleon_28, 0,20);
                              break;
                     }
                   break;
#endif

#ifdef TFT035
     case EA_TFT035: switch(nr)
                      { case 1:  background = RGB565(222,130,0);
                                 TFTbitmap(0,0, DisplayVisions_140x60, 0,0);
                                 TFTfill(WHITE, 140,0, gTFTwidth-1, 59);
                                 setTFTcolor(BLACK, WHITE);
                                 setTFTfont(FONT_8X16, 2,2);
                                 x = (Portrait) ? 144 : 200;
                                 TFTtext(x,14, "TFT035-34AI");
                                 TFTfill(background, 0,60, gTFTwidth-1, gTFTheight-1);
                                 setTFTcolor(WHITE, background);
                                 setTFTfont(FONT_8X16, 2,2);
                                 if(Portrait)
                                  {  x = 0;  y = 90;  s = 50; }
                                 else
                                  {  x = 60;  y = 70;  s = 40; }
                                          TFTtext(x,y, "- 3.5\" IPS-Display");
                                 y += s;  TFTtext(x,y, "- 480x320 dots");
                                 y += s;  TFTtext(x,y, "- 3.3V single supply");
                                 y += s;  TFTtext(x,y, "- -20\xF8..+70\xF8 (TOP.)");
                                 y += s;  TFTtext(x,y, "- controller HX8357D");
                                 y += s;  TFTtext(x,y, "- wide viewing angle");
                              break;
 
                        case 2:  if(Portrait)
                                    TFTbitmap(0,0, Flower_35, 90,0);
                                 else
                                    TFTbitmap(0,0, Flower_35, 0,100);
                              break;

                        case 3:  if(Portrait)
                                    TFTbitmap(0,0, Eule_35, 120,0);
                                 else
                                    TFTbitmap(0,0, Eule_35, 0,40);
                              break;
                       }
                   break;
#endif
      }
   }
}
